#ifndef MUSIC_TREE_H
#define MUSIC_TREE_H

#include <gtkmm/messagedialog.h>
#include <gtkmm/liststore.h>
#include <gtkmm/treeview.h>
#include <iostream>
#include <glibmm/ustring.h>
#include "network.h"

using namespace Gtk;
using namespace std;

#define SEARCH_URL "http://musicmini.baidu.com/app/link/getLinks.php?linkType=1&isLogin=2&clientVer=8.2.5.2&isHq=1&songAppend=&isCloud=0&hasMV=1&songId=%1&songTitle=&songArtist="


class MusicTree : public TreeView
{
public:
	MusicTree(Window *parent = 0);

	void clear();
	void append_row_data(string &title, string &musicID, string &artists);
	void set_parent_window(Window*);

protected:
	class MusicData : public TreeModelColumnRecord
	{
	public:
		MusicData()
		{ add(m_Title); add(m_Artists); add(m_MusicID);}

		TreeModelColumn<Glib::ustring> m_Title;
		TreeModelColumn<Glib::ustring> m_Artists;
		TreeModelColumn<Glib::ustring> m_MusicID;
	};

	Menu			m_Menu_Popup;
	MusicData	m_Data;
	NetWork		m_http;
	Window		*m_parent;
	string		search_str;
	Glib::RefPtr<ListStore> m_ListStore ;

	virtual bool on_button_press_event(GdkEventButton *event);
	//signal han
	void on_menu_player();
	void on_menu_downloads();
	void on_readFinish(Response *response);
	void on_menu_downloads_window();
};
#endif
