#ifndef NETWORK_H
#define NETWORK_H 

#include <iostream>
#include <string>
#include <sigc++/sigc++.h>
#include <glibmm/ustring.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <unistd.h>
#include <thread>
#include <pthread.h>
#include <string.h>
#include <cstdio>
#include <signal.h>
#include <errno.h>
#include "response.h"
#include <list>
#include <mutex>

#define EMITSIGNAL	SIGUSR1+5

class NetWork 
{
public:
	NetWork(std::string url = "", std::string mothod = "");
	~NetWork();

	bool	set_url(const std::string &url);
	void set_mothod(const std::string &mothod);
	void	append_request_head(const std::string &headerName, const std::string &headerValue);
	virtual Response*	get();

	void	emit_signal(Response *response);
protected: 
	int  Connect_to_server();
	void create_requestHead();
	bool send_server(int sockfd);
	void start(pthread_t pid, Response *respon);
	bool analysis_url(const std::string &url);
	virtual bool	recv_server(int, pthread_t, Response*);

	std::string	m_host, m_path, m_mothod;
	std::string m_requestHead, m_append;
	//signal handler
	typedef sigc::signal<void, Response*> type_signal_something;
	type_signal_something m_signal_something;

public:
	type_signal_something signal_something();
};

typedef struct arg {
	NetWork *network;
	Response *response;
} LISTARG;

#endif
