#include "response.h"

Response::Response()
{
}

Response::~Response()
{
}

Response::Response(Response &res)
{
	m_head = res.m_head;
	m_text = res.m_text;
}

std::string Response::get_Response_head()
{
	return m_head;
}

std::string Response::get_Response_text()
{
	return m_text;
}

int Response::data_to_head(const std::string &data)
{
	int pos = 0;

	if( (pos = data.find("\r\n\r\n", 0)) == std::string::npos) {
		return -1;
	}
	m_head.clear();
	m_head.assign(data, 0, pos);
	pos += 4;

	return pos;
}

int Response::data_to_text(const std::string &data, int pos)
{
	std::string num, str;
	int ret, n;

	m_text.clear();
	ret = get_Response_sign("Transfer-Encoding", &str);
	if(ret > 0 && str == "chunked") {
		do {
			if(Strcpy(&num, data, pos, '\r') <= 0) {
				break;
			}
			sscanf(num.c_str(), "%x", &n);
			if(n <= 0) {
				break;
			}
			m_text.append(data, pos += num.size() + 2, n);
			pos += n;
		} while(/*(data.find("\r\n", pos) != std::string::npos) &&*/(pos += 2));
	} else {
		m_text.assign(data, pos, data.size());
	}

	return pos;
}

int Response::get_Response_sign(const std::string &sign, std::string *ret)
{
	if(m_head.empty()) {
		std::cout << "Response is empty" << std::endl;
		return -1;
	}
	int pos = 0;

	if( (pos = m_head.find(sign, 0)) == std::string::npos) {
		return true;
	}
	Strcpy(ret, m_head, pos += sign.size() + 2, '\r');

	return pos;
}

int Response::get_Response_code()
{
	if(m_head.empty()) {
		std::cout << "Response is empty" << std::endl;
		return -1;
	}

	std::string str;
	int pos = 0, code;

	if( (pos = m_head.find(" ", 0)) == std::string::npos) {
		std::cout << "Not found response code" << std::endl;
		return -2;
	}
	Strcpy(&str, m_head, pos, 20);
	sscanf(str.c_str(), "%d", &code);

	return code;
}

int Strcpy(std::string *dst, const std::string &src, int pos, char end)
{
	int count = 0, size = 0;

	dst->clear();
	size = src.size();
	while(src[pos] != end && count < size) {
		*dst += src[pos++];
		count++;
	}

	return count;
}
